<?php
	/* 
		WildFire
		v 1.5.0 Build 0005 - 8/20/2012
		Copyright 2012, Firelight Business Enterprises, Inc.
	*/
	class wf_module_email{
		private $installer;

		function __construct(){
			global $installer;
			$this->installer = $installer;
		}

		function wf_module_email(){
			global $installer;
			$this->installer = $installer;
		}

		function kit__cpanel_create_email_address($arguments){
			/*
				{:kit__cpanel_create_email_address[cpanel_user,cpanel_password,cpanel_host,cpanel_skin,domain,email,password, quota]:}
				Returns: none
			*/
				error_log("kit__cpanel_create_email_address: ".print_r($arguments, true));
			$this->kit__cpanel_api_create_email_address(array($arguments[0],$arguments[1],$arguments[2],$arguments[5],$arguments[4],$arguments[6],$arguments[7]));
		}	
	
		function kit__cpanel_create_email_forwarder($arguments){
			/*
				{:kit__cpanel_create_email_forwarder[cpanel_user,cpanel_password,cpanel_host,cpanel_skin,address,domain,fwdoption(default fwd, fail, pipe, blackhole), fwdemail, pipefwd]:}
				Returns: none
			*/
			$cpanel_user = $arguments[0];
			$cpanel_password = $arguments[1];
			$cpanel_host = $arguments[2];
			$cpanel_skin = $arguments[3];
			$address = $arguments[4];
			$domain = $arguments[5];
			if ($arguments[6]){
				$fwdoption = $arguments[6];
			}else{
				$fwdoption = "fwd";
			}
			if ($arguments[7]){
				$fwdemail = $arguments[7];
			}else{
				$fwdemail = "";
			}
			if ($arguments[8]){
				$pipefwd = $arguments[8];
			}else{
				$pipefwd = "";
			}
			$port = ($this->installer->__kit_vars['_serversecure']=="on") ? "2083" : "2082";
			$host = ($this->installer->__kit_vars['_serversecure']=="on") ? "https" : "http";
			$b = $this->http_get_request("", $cpanel_host, $port, $cpanel_user, $cpanel_password, "/frontend/$cpanel_skin/mail/doaddfwd.html?email=".$address."&domain=".$domain."&fwdopt=".$fwdoption."&fwdemail=".$fwdemail."&pipefwd=".$pipefwd."&ALL=ALL");
			if (!$b){
				$this->installer->kit__log_add(array("CPanel - Error adding email forwarder."));
			}
		}	
	
		function kit__cpanel_api_create_email_address($arguments){			
			/*
				{:kit__cpanel_api_create_email_address[cpanel_user,cpanel_password,cpanel_host,domain,email,password,quota]:}
				Returns: none
			*/
			$cpanel_user = $arguments[0];
			$cpanel_password = $arguments[1];
			$cpanel_host = $arguments[2];
			$args = array(
				'domain' => $arguments[3],
				'email' => $arguments[4],
				'password' => $arguments[5],
				'send_welcome_email' => 0,
				'cpanel_xmlapi_module' => "Email",
				'cpanel_xmlapi_func' => "addpop",
				'cpanel_xmlapi_apiversion' => 2
			);
			
			$this->cpanel_api_query_create_email(array($cpanel_user,$cpanel_password,$cpanel_host,"cpanel",$args));
		}

		function cpanel_api_query_create_email($arguments){
			$cpanel_user = $arguments[0];
            $cpanel_pass = $arguments[1];
            $host = $arguments[2];
            $domain = $arguments[4]['domain'];
            $email = $arguments[4]['email'];
            $password = $arguments[4]['password'];
            $send_welcome_email = $arguments[4]['send_welcome_email'];
            
            $port = ($this->installer->__kit_vars['cp__serversecure']=="on") ? "2083" : "2082";
			$protocol = ($this->installer->__kit_vars['cp__serversecure']=="on") ? "https" : "http";
            
            $api_query = $protocol."://".$host.":".$port."/json-api/cpanel?cpanel_jsonapi_user=".$cpanel_user."&cpanel_jsonapi_apiversion=2&cpanel_jsonapi_module=Email&cpanel_jsonapi_func=addpop&domain=" . $domain . "&email=" . $email . "&password=" . $password;

            //error_log("api_query_create_email: ".$api_query);
            
            $curl = curl_init(); 
            curl_setopt($curl, CURLOPT_SSL_VERIFYPEER,0);
            curl_setopt($curl, CURLOPT_SSL_VERIFYHOST,0);
            curl_setopt($curl, CURLOPT_HEADER,0);
            curl_setopt($curl, CURLOPT_RETURNTRANSFER,1);
            $header[0] = "Authorization: Basic " . base64_encode($cpanel_user.":".$cpanel_pass) . "\n\r";
            curl_setopt($curl, CURLOPT_HTTPHEADER, $header);
            curl_setopt($curl, CURLOPT_URL, $api_query);
            $result = curl_exec($curl);
            //error_log("cpanel_api_query_create_email_result: ".print_r($result, true));
            if ($result === false) {
                error_log("Error: ".curl_error($curl));
                $this->installer->kit__log_add(array("Error: ".curl_error($curl)));
            }
            curl_close($curl);
		}

		function cpanel_api_query($arguments){
			/*
				{:cpanel_api_query[cpanel_user,cpanel_pass,domain,function,query]:}
				Returns: none
			*/
			if (function_exists('curl_setopt')){
				return $this->cpanel_api_curl($arguments);
			}elseif (ini_get('allow_url_fopen')){
				return $this->cpanel_api_fopen($arguments);
			}else{
				$this->installer->kit__log_add(array("cUrl and allow_url_fopen are not available on your server."));
			}
		}
	
		function cpanel_api_curl($arguments) {
			$port = ($this->installer->__kit_vars['cp__serversecure']=="on") ? "2083" : "2082";
			$host = ($this->installer->__kit_vars['cp__serversecure']=="on") ? "https" : "http";
			$api_query = $host."://".$arguments[2].":".$port."/xml-api/".$arguments[3];
			$function_arguments = http_build_query($arguments[4], '', '&');
			$curl = curl_init();		
			curl_setopt($curl, CURLOPT_SSL_VERIFYPEER,0);
			curl_setopt($curl, CURLOPT_SSL_VERIFYHOST,0); 	
			curl_setopt($curl, CURLOPT_RETURNTRANSFER,1);
			curl_setopt($curl, CURLOPT_POST, 1);
			curl_setopt($curl, CURLOPT_URL, $api_query);
			curl_setopt($curl, CURLOPT_TIMEOUT, 15);
			
			$header[] = "Authorization: Basic " . base64_encode($arguments[0].":".$arguments[1]) . "\r\n" . 
					"Content-Type: application/x-www-form-urlencoded\r\n" . 
					"Content-Length: " . strlen($function_arguments) . "\r\n" . "\r\n" . $function_arguments;
			curl_setopt($curl, CURLOPT_HTTPHEADER, $header);
			$result = curl_exec($curl);
			if ($result == false) {
				$this->installer->kit__log_add(array("cAPI(crl) - ". curl_error($curl)));
			}else{
				$xml = @simplexml_load_string($result);
				if ($xml->data->status){
					$status = $xml->data->status;
				}elseif ($xml->data->result){
					$status = $xml->data->result;
				}elseif ($xml->data->event->result){
					$status = $xml->data->event->result;
				}
				if ($status==0){
					$the_m = trim($xml->data->statusmsg?$xml->data->statusmsg:$xml->data->reason);
					if ($the_m !=""){
						$message = $the_m." (";
						$message .="M: ".$arguments[4]['cpanel_xmlapi_module']." - F: ".$arguments[4]['cpanel_xmlapi_func'].")";
						$this->installer->kit__log_add(array("cAPI - ". $message));
					}
				}		
				return $result;
			}
			curl_close($curl);
		}
	
		function cpanel_api_fopen($arguments){
			$port = ($this->installer->__kit_vars['cp__serversecure']=="on") ? "2083" : "2082";
			$host = ($this->installer->__kit_vars['cp__serversecure']=="on") ? "https" : "http";
			$api_query = $host."://".$arguments[2].":".$port."/xml-api/".$arguments[3];
			$function_arguments = http_build_query($arguments[4], '', '&');
			$options = array(
				'http' => array(
					'allow_self_signed' => true,
					'method' => 'POST',
					'header' => "Authorization: Basic " . base64_encode($arguments[0].":".$arguments[1]) . "\n\r" .
						"Content-Type: application/x-www-form-urlencoded\r\n" .
						"Content-Length: " . strlen($function_arguments) . "\r\n" .
						"\r\n" . $function_arguments
				)
			);
			$context = stream_context_create($options);
			return file_get_contents($api_query, false, $context);
		}
	}
?>